#! /srvtools/http/bin/perl
#############################################################################
#
#   Copyright 1995 by the Northeast Parallel Architectures Center at 
#   Syracuse University and Global Business Network, Inc..
#  
#   File:          Entry2.pl
#
#   Authors:       Jungmin Kim and Paul Coddington (paulc@npac.syr.edu)
#
#   Created:       04/25/95
#   Modified:      
#   Version: 
#
#   Input:         VOID
#   Output:        HTML text
#          
#
#   Description:   Create fill-out forms to get user name and email address
#                   for the case where no password is required.
#               
#   Usage:         "http://.../WeBBoard/subdir"
#
#   Updates: 
#
#   July 10 1995 by PDC
#   - Added pointer to WeBBoard home page and copyright information.
#
#
#############################################################################

require "npac-lib";       # Library of useful subroutines
require "Address.pl";  

sub Entry2{
   local($subdir) = @_;
   local($header,$footer);

   &PrintContentType();

   # Print Entry header file for this WeBBoard
   &PrintFile("$subdir/HTML/EntryHeader.html", $webboardhome);

if ($subdir ne "") {
   # Form to enter username
   print "<FORM METHOD=\"POST\" ACTION=\"$action\/$subdir\:check\">\n";
   print "<b>Enter your name </b>\: \n";
   print "<INPUT SIZE=30 TYPE=\"text\" NAME=\"username\" VALUE=\"\">\n";
   print "<INPUT TYPE=\"submit\" VALUE=\"SUBMIT\"> \n";
   print "</FORM>\n";
   print "<P>\n";
   print "<B>or if you are a first-time user, see the \n";
   print "<A HREF=\"$intro\">introduction to WebBoard</A>.</B>\n";
}

   # Print Entry footer file for this WeBBoard
   &PrintFile("$subdir/HTML/EntryFooter.html", $webboardhome);

   # Print address and copyright information
   &Address($subdir);

}

1;

